org.apache.commons.compress.archivers.tar

## Class TarArchiveInputStream

- java.lang.Object
- - java.io.InputStream
  - - org.apache.commons.compress.archivers.ArchiveInputStream
    - - org.apache.commons.compress.archivers.tar.TarArchiveInputStream

- All Implemented Interfaces:
    Closeable, AutoCloseable

      public class TarArchiveInputStream
      extends ArchiveInputStream

  The TarInputStream reads a UNIX tar archive as an InputStream. methods are provided to position at each successive entry in the archive, and the read each entry as a normal input stream using read().
  This class is not thread-safe

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `TarArchiveInputStream(InputStream is)` Constructor for TarInputStream.
    `TarArchiveInputStream(InputStream is, boolean lenient)` Constructor for TarInputStream.
    `TarArchiveInputStream(InputStream is, int blockSize)` Constructor for TarInputStream.
    `TarArchiveInputStream(InputStream is, int blockSize, int recordSize)` Constructor for TarInputStream.
    `TarArchiveInputStream(InputStream is, int blockSize, int recordSize, String encoding)` Constructor for TarInputStream.
    `TarArchiveInputStream(InputStream is, int blockSize, int recordSize, String encoding, boolean lenient)` Constructor for TarInputStream.
    `TarArchiveInputStream(InputStream is, int blockSize, String encoding)` Constructor for TarInputStream.
    `TarArchiveInputStream(InputStream is, String encoding)` Constructor for TarInputStream.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Get the available data that can be read from the current entry in the archive.
    `boolean` | `canReadEntryData(ArchiveEntry ae)` Whether this class is able to read the given entry.
    `void` | `close()` Closes this stream.
    `TarArchiveEntry` | `getCurrentEntry()` Get the current TAR Archive Entry that this input stream is processing
    `protected byte[]` | `getLongNameData()` Get the next entry in this tar archive as longname data.
    `ArchiveEntry` | `getNextEntry()` Returns the next Archive Entry in this Stream.
    `TarArchiveEntry` | `getNextTarEntry()` Get the next entry in this tar archive.
    `int` | `getRecordSize()` Get the record size being used by this stream's buffer.
    `protected boolean` | `isAtEOF()`
    `protected boolean` | `isEOFRecord(byte[] record)` Determine if an archive record indicate End of Archive.
    `void` | `mark(int markLimit)` Since we do not support marking just yet, we do nothing.
    `boolean` | `markSupported()` Since we do not support marking just yet, we return false.
    `static boolean` | `matches(byte[] signature, int length)` Checks if the signature matches what is expected for a tar file.
    `int` | `read(byte[] buf, int offset, int numToRead)` Reads bytes from the current tar archive entry.
    `protected byte[]` | `readRecord()` Read a record from the input stream and return the data.
    `void` | `reset()` Since we do not support marking just yet, we do nothing.
    `protected void` | `setAtEOF(boolean b)`
    `protected void` | `setCurrentEntry(TarArchiveEntry e)`
    `long` | `skip(long n)` Skips over and discards `n` bytes of data from this input stream.

    - ### Methods inherited from class org.apache.commons.compress.archivers.ArchiveInputStream

      `count, count, getBytesRead, getCount, pushedBackBytes, read`

    - ### Methods inherited from class java.io.InputStream

      `read`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TarArchiveInputStream

          public TarArchiveInputStream(InputStream is)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use

    - #### TarArchiveInputStream

          public TarArchiveInputStream(InputStream is,
                                       boolean lenient)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use
        `lenient` - when set to true illegal values for group/userid, mode, device numbers and timestamp will be ignored and the fields set to `TarArchiveEntry.UNKNOWN`. When set to false such illegal fields cause an exception instead.
      Since:
        1.19

    - #### TarArchiveInputStream

          public TarArchiveInputStream(InputStream is,
                                       int blockSize)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use
        `blockSize` - the block size to use

    - #### TarArchiveInputStream

          public TarArchiveInputStream(InputStream is,
                                       int blockSize,
                                       int recordSize)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use
        `blockSize` - the block size to use
        `recordSize` - the record size to use

    - #### TarArchiveInputStream

          public TarArchiveInputStream(InputStream is,
                                       int blockSize,
                                       int recordSize,
                                       String encoding)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use
        `blockSize` - the block size to use
        `recordSize` - the record size to use
        `encoding` - name of the encoding to use for file names
      Since:
        1.4

    - #### TarArchiveInputStream

          public TarArchiveInputStream(InputStream is,
                                       int blockSize,
                                       int recordSize,
                                       String encoding,
                                       boolean lenient)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use
        `blockSize` - the block size to use
        `recordSize` - the record size to use
        `encoding` - name of the encoding to use for file names
        `lenient` - when set to true illegal values for group/userid, mode, device numbers and timestamp will be ignored and the fields set to `TarArchiveEntry.UNKNOWN`. When set to false such illegal fields cause an exception instead.
      Since:
        1.19

    - #### TarArchiveInputStream

          public TarArchiveInputStream(InputStream is,
                                       int blockSize,
                                       String encoding)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use
        `blockSize` - the block size to use
        `encoding` - name of the encoding to use for file names
      Since:
        1.4

    - #### TarArchiveInputStream

          public TarArchiveInputStream(InputStream is,
                                       String encoding)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use
        `encoding` - name of the encoding to use for file names
      Since:
        1.4

  - ### Method Detail

    - #### matches

          public static boolean matches(byte[] signature,
                                        int length)

      Checks if the signature matches what is expected for a tar file.
      Parameters:
        `signature` - the bytes to check
        `length` - the number of bytes to check
      Returns:
        true, if this stream is a tar archive stream, false otherwise

    - #### available

          public int available()
                        throws IOException

      Get the available data that can be read from the current entry in the archive. This does not indicate how much data is left in the entire archive, only in the current entry. This value is determined from the entry's size header field and the amount of data already read from the current entry. Integer.MAX_VALUE is returned in case more than Integer.MAX_VALUE bytes are left in the current entry in the archive.
      Overrides:
        `available` in class `InputStream`
      Returns:
        The number of available bytes for the current entry.
      Throws:
        `IOException` - for signature

    - #### canReadEntryData

          public boolean canReadEntryData(ArchiveEntry ae)

      Whether this class is able to read the given entry.
      Overrides:
        `canReadEntryData` in class `ArchiveInputStream`
      Parameters:
        `ae` - the entry to test
      Returns:
        The implementation will return true if the `ArchiveEntry` is an instance of `TarArchiveEntry`

    - #### close

          public void close()
                     throws IOException

      Closes this stream. Calls the TarBuffer's close() method.
      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Overrides:
        `close` in class `InputStream`
      Throws:
        `IOException` - on error

    - #### getCurrentEntry

          public TarArchiveEntry getCurrentEntry()

      Get the current TAR Archive Entry that this input stream is processing
      Returns:
        The current Archive Entry

    - #### getLongNameData

          protected byte[] getLongNameData()
                                    throws IOException

      Get the next entry in this tar archive as longname data.
      Returns:
        The next entry in the archive as longname data, or null.
      Throws:
        `IOException` - on error

    - #### getNextEntry

          public ArchiveEntry getNextEntry()
                                    throws IOException

      Returns the next Archive Entry in this Stream.
      Specified by:
        `getNextEntry` in class `ArchiveInputStream`
      Returns:
        the next entry, or `null` if there are no more entries
      Throws:
        `IOException` - if the next entry could not be read

    - #### getNextTarEntry

          public TarArchiveEntry getNextTarEntry()
                                          throws IOException

      Get the next entry in this tar archive. This will skip over any remaining data in the current entry, if there is one, and place the input stream at the header of the next entry, and read the header and instantiate a new TarEntry from the header bytes and return that entry. If there are no more entries in the archive, null will be returned to indicate that the end of the archive has been reached.
      Returns:
        The next TarEntry in the archive, or null.
      Throws:
        `IOException` - on error

    - #### getRecordSize

          public int getRecordSize()

      Get the record size being used by this stream's buffer.
      Returns:
        The TarBuffer record size.

    - #### isAtEOF

          protected final boolean isAtEOF()

    - #### isEOFRecord

          protected boolean isEOFRecord(byte[] record)

      Determine if an archive record indicate End of Archive. End of archive is indicated by a record that consists entirely of null bytes.
      Parameters:
        `record` - The record data to check.
      Returns:
        true if the record data is an End of Archive

    - #### mark

          public void mark(int markLimit)

      Since we do not support marking just yet, we do nothing.
      Overrides:
        `mark` in class `InputStream`
      Parameters:
        `markLimit` - The limit to mark.

    - #### markSupported

          public boolean markSupported()

      Since we do not support marking just yet, we return false.
      Overrides:
        `markSupported` in class `InputStream`
      Returns:
        False.

    - #### read

          public int read(byte[] buf,
                          int offset,
                          int numToRead)
                   throws IOException

      Reads bytes from the current tar archive entry. This method is aware of the boundaries of the current entry in the archive and will deal with them as if they were this stream's start and EOF.
      Overrides:
        `read` in class `InputStream`
      Parameters:
        `buf` - The buffer into which to place bytes read.
        `offset` - The offset at which to place bytes read.
        `numToRead` - The number of bytes to read.
      Returns:
        The number of bytes read, or -1 at EOF.
      Throws:
        `IOException` - on error

    - #### readRecord

          protected byte[] readRecord()
                               throws IOException

      Read a record from the input stream and return the data.
      Returns:
        The record data or null if EOF has been hit.
      Throws:
        `IOException` - on error

    - #### reset

          public void reset()

      Since we do not support marking just yet, we do nothing.
      Overrides:
        `reset` in class `InputStream`

    - #### setAtEOF

          protected final void setAtEOF(boolean b)

    - #### setCurrentEntry

          protected final void setCurrentEntry(TarArchiveEntry e)

    - #### skip

          public long skip(long n)
                    throws IOException

      Skips over and discards `n` bytes of data from this input stream. The `skip` method may, for a variety of reasons, end up skipping over some smaller number of bytes, possibly `0`. This may result from any of a number of conditions; reaching end of file or end of entry before `n` bytes have been skipped; are only two possibilities. The actual number of bytes skipped is returned. If `n` is negative, no bytes are skipped.
      Overrides:
        `skip` in class `InputStream`
      Parameters:
        `n` - the number of bytes to be skipped.
      Returns:
        the actual number of bytes skipped.
      Throws:
        `IOException` - if a truncated tar archive is detected or some other I/O error occurs

Copyright © 2002–2022 The Apache Software Foundation. All rights reserved.